/****************************************************************************
 *	Copylight(C) 2018 Kanazawa-soft-design,LLC.
 ****************************************************************************/
/*!
 *	@file	FileDataView.h
 *
 *	@brief	t@C̓eoCi\r[.
 *
 *	@author	V 閾
 */
#pragma once

#include "WrapScrollBar.h"

/****************************************************************************
 *
 * NX`.
 *
 ****************************************************************************/
/*!
 *
 *	@brief	t@CeoCi\r[̃NX.
 *
 */
class CFileDataView : public CView
{
	DECLARE_DYNCREATE( CFileDataView )

protected:
			 CFileDataView();
	virtual	~CFileDataView();

public:
	virtual void OnDraw( CDC* pDC );

	#ifdef _DEBUG
	virtual void AssertValid() const;
	#ifndef _WIN32_WCE
	virtual void Dump( CDumpContext& dc ) const;
	#endif
	#endif

	void	Clear( void );

protected:
	DECLARE_MESSAGE_MAP()

private:
	void	DrawMain( CDC* pDC, CRect& area );
	void	DrawScale( CDC* pDC, CRect& area, int fontH, int fontW );
	void	DrawBinaryData( CDC* pDC, BYTE* buf, DWORD size, int line, int fontH, int fontW, DWORD adr );
	BOOL	CreateFont( CFont& font );
	void	SetScrollBar( void );

private:
	CWrapScrollBar	m_ScrollV;			//!< ̃XN[o[.
	CWrapScrollBar	m_ScrollH;			//!< ̃XN[o[.

public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
 };

/* End of file */
