/****************************************************************************
 *	Copylight(C) 2018 Kanazawa-soft-design,LLC.
 ****************************************************************************/
/*!
 *	@file	FileTreeView.h
 *
 *	@brief	fBNgc[\r[.
 *
 *	@author	V 閾
 */
#pragma once


/****************************************************************************
 *
 * NX`.
 *
 ****************************************************************************/
/*!
 *
 *	@brief	fBNgc[\r[̃NX.
 *
 */
class CFileTreeView : public CTreeView
{
	DECLARE_DYNCREATE( CFileTreeView )

protected:
			 CFileTreeView();
	virtual ~CFileTreeView();

public:
	#ifdef _DEBUG
		virtual void AssertValid() const;
	#ifndef _WIN32_WCE
		virtual void Dump( CDumpContext& dc ) const;
	#endif
	#endif

protected:
	DECLARE_MESSAGE_MAP()

public:
	virtual void OnInitialUpdate();
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);

public:
	afx_msg void OnTvnItemexpanded(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnSelchanged(NMHDR *pNMHDR, LRESULT *pResult);

public:
	void		ExpandAndSelectDirectory( CString& path );

private:
	HTREEITEM	AddRootNode( CTreeCtrl& treeCtrl );
	void		AddDriveName( CTreeCtrl& treeCtrl, HTREEITEM hParent );
	void		AddDirectory( CTreeCtrl& treeCtrl, HTREEITEM hParent, CString path, BOOL isDummy );
	CString		GetAbsolutePath( CTreeCtrl& treeCtrl, HTREEITEM hItem );
	void		DeleteChildItems( CTreeCtrl& treeCtrl, HTREEITEM hItem );
};

/* End of file */
