/****************************************************************************
 *	Copylight(C) 2018 Kanazawa-soft-design,LLC.
 ****************************************************************************/
/*!
 *	@file	MFCApp001Doc.cpp
 *
 *	@brief	hLgNX.
 *
 *	@author	V 閾
 */
#include "stdafx.h"
// SHARED_HANDLERS ́Avr[AkŁAьtB^[ nh[Ă ATL vWFNgŒ`łA
// ̃vWFNgƂ̃hLg R[h̋L\ɂ܂B
#ifndef SHARED_HANDLERS
#include "MFCApp001.h"
#endif

#include "MFCApp001Doc.h"
#include "FileTreeView.h"
#include "FileListView.h"
#include "FileDataView.h"

#include <propkey.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMFCApp001Doc

IMPLEMENT_DYNCREATE(CMFCApp001Doc, CDocument)

BEGIN_MESSAGE_MAP(CMFCApp001Doc, CDocument)
END_MESSAGE_MAP()

/****************************************************************************/
/*!
 *	@brief	RXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CMFCApp001Doc::CMFCApp001Doc()
{
	m_CurrentDir = _T("");
	m_FileBuff   = NULL;
	m_FileSize   = 0;
}

/****************************************************************************/
/*!
 *	@brief	fXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CMFCApp001Doc::~CMFCApp001Doc()
{
	//! t@CXg.
	ClearFileList();

	//! t@Cobt@.
	if( m_FileBuff ){
		delete [] m_FileBuff;
	}
}

/****************************************************************************/
/*!
 *	@brief	VhLg𐶐.
 *
 *	@param	Ȃ.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
BOOL CMFCApp001Doc::OnNewDocument()
{
	//! ŏɊNX̃\bhĂяo.
	if( !CDocument::OnNewDocument() ){
		return FALSE;
	}
	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B

	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	VA.
 *
 *	@param	[in]	ar	
 *
 *	@retval	Ȃ.
 */
void CMFCApp001Doc::Serialize( CArchive& ar )
{
	if( ar.IsStoring() ){
		// TODO: i[R[hɒǉĂB
	}else{
		// TODO: ǂݍރR[hɒǉĂB
	}
}

/****************************************************************************/
/*!
 *	@brief	t@CꗗXV.
 *
 *	@param	[in]	path	ꗗ\pX.
 *
 *	@retval	Ȃ.
 */
void CMFCApp001Doc::UpdateFileList( CString& path )
{
	//! ꗗ\pXۑ.
	m_CurrentDir = path;

	if( path.GetLength() > 0 ){
		//! w肳ꂽpX̃t@Cꗗ𐶐.
		CreateFileList( path );
	}else{
		//! pXw肳ĂȂꍇ̓hCuꗗ𐶐.
		CreateDriveList();
	}
	//! t@CꗗXV.
	CFileListView* listView = GetFileListView();
	if( listView != NULL ){
		listView->UpdateFileList();
	}
}

/****************************************************************************/
/*!
 *	@brief	w肵fBNgWJ\.
 *
 *	@param	[in]	path	WJfBNg̐΃pX.
 *
 *	@retval	Ȃ.
 */
void CMFCApp001Doc::ExpandDirectory( CString& path )
{
	CFileTreeView* treeView = GetFileTreeView();
	if( treeView != NULL ){
		//! fBNgc[̊YfBNgWJ.
		treeView->ExpandAndSelectDirectory( path );

		//! t@CꗗXV.
		UpdateFileList( path );
	}
}

/****************************************************************************/
/*!
 *	@brief	fBNgc[r[̃IuWFNg擾.
 *
 *	@param	Ȃ.
 *
 *	@retval	fBNgc[r[IuWFNg̃|C^.
 */
CFileTreeView* CMFCApp001Doc::GetFileTreeView( void )
{
	POSITION pos = GetFirstViewPosition();
	while( pos != NULL ){
		CView* pView = GetNextView( pos );
		if( pView->IsKindOf( RUNTIME_CLASS(CFileTreeView) ) ) {
			return dynamic_cast<CFileTreeView*>( pView );
		}
	}
	return NULL;
}

/****************************************************************************/
/*!
 *	@brief	t@Cꗗr[̃IuWFNg擾.
 *
 *	@param	Ȃ.
 *
 *	@retval	t@Cꗗr[IuWFNg̃|C^.
 */
CFileListView* CMFCApp001Doc::GetFileListView( void )
{
	POSITION pos = GetFirstViewPosition();
	while( pos != NULL ){
		CView* pView = GetNextView( pos );
		if( pView->IsKindOf( RUNTIME_CLASS(CFileListView) ) ) {
			return dynamic_cast<CFileListView*>( pView );
		}
	}
	return NULL;
}

/****************************************************************************/
/*!
 *	@brief	t@Ce̕\r[̃IuWFNg擾.
 *
 *	@param	Ȃ.
 *
 *	@retval	t@Ce̕\r[IuWFNg̃|C^.
 */
CFileDataView* CMFCApp001Doc::GetFileDataView( void )
{
	POSITION pos = GetFirstViewPosition();
	while( pos != NULL ){
		CView* pView = GetNextView( pos );
		if( pView->IsKindOf( RUNTIME_CLASS(CFileDataView) ) ) {
			return dynamic_cast<CFileDataView*>( pView );
		}
	}
	return NULL;
}

/****************************************************************************/
/*!
 *	@brief	hCũXg擾.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	CMFCApp001Doc::CreateDriveList( void )
{
	//! t@CXgNA.
	ClearFileList();

	//! LȃhCu̕擾.
	TCHAR buf[128] = {'\0'};
	DWORD size     = sizeof( buf ) / sizeof( buf[0] );
	::GetLogicalDriveStrings( size, buf );

	/*!
	 * 擾hCũXg͈ȉ̂悤ɂȂĂ.
	 *
	 * "C:\" + '\0' + "D:\" + '\0' + '\0'
	 */
	for( LPTSTR ptr = buf ; *ptr != _T('\0') ; ){

		//! hCu񂩂obNXbV('\')菜.
		CString path = ptr;
		path.Remove( _T('\\') );

		//! t@C𐶐.
		CFileInfo* info = new CFileInfo();
		info->SetFileName( path );
//		info->SetFileSize( CString( _T("<DRIVE>") ));

		//! t@CXgɐt@Cǉ.
		m_FileList.Add( info );

		//! ( + NULL)ǂݔ΂Ď̐̕擪ֈړ.
		ptr += (_tcslen( ptr ) + 1);
	}
}

/****************************************************************************/
/*!
 *	@brief	w肳ꂽfBNg̃t@Cꗗ擾.
 *
 *	@param	[in]	path	t@Cꗗ擾fBNg̐΃pX̃|C^.
 *
 *	@retval	Ȃ.
 */
void	CMFCApp001Doc::CreateFileList( CString& path )
{
	//! t@CXgNA.
	ClearFileList();

	CString buf = path;
	buf += _T("\\*.*");

	WIN32_FIND_DATA ffd;
	memset( &ffd, 0, sizeof(WIN32_FIND_DATA) );

	try {
		/*!
		 * JgfBNg̉ɂfBNgƃt@C𒊏o.
		 * ABfBNgƃJgfBNg( "." ) ̓XgɊ܂߂Ȃ.
		 */
		HANDLE sch = ::FindFirstFile( (LPCTSTR)buf, &ffd );
		if( sch != INVALID_HANDLE_VALUE ){
			do{
				if( !( ffd.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN )
				&&   ( _tcscmp( ffd.cFileName, _T(".")  ) != 0      )
				&&   ( _tcscmp( ffd.cFileName, _T("..") ) != 0      )){

					//! t@C𐶐.
					CFileInfo* info = new CFileInfo();
					info->SetFileName( CString( ffd.cFileName ) );

					//! t@Ctɂ̓t@C̍ŏIXVZbg.
					info->SetFileDate( ConvertFileDate( ffd.ftLastWriteTime ) );

					if( ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ){
						info->SetType( CFileInfo::TYPE_DIR );

						//! fBNg̏ꍇAt@CTCYɁu<DIR>vZbg.
						info->SetFileSize( CString(_T("<DIR>")) );
					}else{
						info->SetType( CFileInfo::TYPE_FILE );

						//! t@C̏ꍇAt@CTCYZbg.
						LONGLONG size = (LONGLONG)((DWORDLONG)ffd.nFileSizeHigh << 32) + ((DWORDLONG)ffd.nFileSizeLow);
						info->SetFileSize( DigitSeparator( size ) );
					}
					/*!
					 * t@CXgɐt@Cǉ.
					 * (t@CXgɂ̓fBNgt@C̏ɁAAOɊi[)
					 */
					int i;
					for( i = 0; i < m_FileList.GetCount(); i++ ){
						//! t@CXg̐擪t@C1Âo.
						CFileInfo* item = m_FileList.GetAt( i );
						if( item->GetType() == info->GetType() ){
							//! t@CʂꍇAOɊi[.
							if( info->GetFileName().CompareNoCase( item->GetFileName() ) < 0 ){
								m_FileList.InsertAt( i, info );
								break;
							}
						}else{
							//! t@CʂςꍇAfBNgɊi[.
							if( info->GetType() == CFileInfo::TYPE_DIR ){
								m_FileList.InsertAt( i, info );
								break;
							}
						}
					}
					if( i >= m_FileList.GetCount() ){
						m_FileList.Add( info );
					}
				}
				memset( &ffd, 0, sizeof(WIN32_FIND_DATA) );

			//! ̃t@C擾.
			}while( ::FindNextFile( sch, &ffd ) ) ;

			//! ̃fBNgɈړׂ́u..vXg̐擪ɒǉ.
			CFileInfo* info = new CFileInfo();
			info->SetType( CFileInfo::TYPE_DIR );
			info->SetFileName( CString( _T("..") ) );
			info->SetFileSize( CString(_T("<DIR>")) );
			m_FileList.InsertAt( 0, info );
		}
	}catch( ... ){
		TRACE0( "t@CXg̐Ɏs܂B\n" );
	}
}

/****************************************************************************/
/*!
 *	@brief	t@CꗗNA.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	CMFCApp001Doc::ClearFileList( void )
{
	//! t@CXgɂt@C.
	for( int i = 0; i < m_FileList.GetCount(); i++ ){
		delete m_FileList.GetAt( i );
	}
	//! ŌɃt@CXĝ.
	m_FileList.RemoveAll();
}

/****************************************************************************/
/*!
 *	@brief	t@Cǂ𒲂ׂ.
 *
 *	@param	[in]	idx		t@Cǂ𒲂ׂt@C̏񂪊i[Ă郊Xg̃CfbNX.
 *
 *	@retval	TRUE = t@C / FALSE = t@CȊO.
 */
BOOL	CMFCApp001Doc::IsFile( int idx )
{
	//! w肳ꂽCfbNX͈͊Ȍꍇ̓G[.
	if( idx >= m_FileList.GetCount() ){
		return FALSE;
	}
	//! t@CXgYt@C̏o.
	CFileInfo* info = m_FileList.GetAt( idx );
	if( info == NULL ){
		return FALSE;
	}
	return (info->GetType() == CFileInfo::TYPE_FILE) ? TRUE : FALSE;
}

/****************************************************************************/
/*!
 *	@brief	t@C̐΃pX擾.
 *
 *	@param	[in]	idx		΃pX擾t@C̏񂪊i[Ă郊Xg̃CfbNX.
 *
 *	@retval	w肳ꂽt@C̐΃pX.
 */
CString	CMFCApp001Doc::GetFilePath( int idx )
{
	CString path = _T("");

	//! w肳ꂽCfbNX͈͊Ȍꍇ̓G[.
	if( idx >= m_FileList.GetCount() ){
		return path;
	}
	//! t@CXgYt@C̏o.
	CFileInfo* info = m_FileList.GetAt( idx );
	if( info == NULL ){
		return path;
	}

	CString name = info->GetFileName();
	if( name.Compare( _T("..") ) == 0 ){
		//! ".."̏ꍇAJgpX̍Ō̃fBNg菜.
		int pos = m_CurrentDir.ReverseFind( _T('\\') );
		if( pos >= 0 ){
			path = m_CurrentDir.Mid( 0, pos );
		}
	}else{
		//! JgpXꍇ̓t@CƘAׂɃpX̍ŌɃZp[^("\")t.
		path = m_CurrentDir;
		if( path.GetLength() > 0 ){
			path += _T("\\");
		}
		//! JgpX + t@CŃt@C̐΃pXɂ.
		path += name;
	}
	return path;
}

/****************************************************************************/
/*!
 *	@brief	w肳ꂽt@C̓eǂݍ.
 *
 *	@param	[in]	filename	ǂݍރt@C̐΃pX.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
BOOL	CMFCApp001Doc::LoadFile( CString& filename )
{
	CFile file;

	//! t@Cǂݍ݃[hŃI[v.
	if( !file.Open( filename, CFile::modeRead | CFile::shareDenyNone ) ){
		return FALSE;
	}
	//! t@C̃oCg擾.
	DWORD size = (DWORD)file.GetLength();

	/*!
	 * t@CTCYǂݍ݃TCY̏𒴂ꍇ
	 * TCY̏܂łǂݍ܂Ȃ.
	 */
	if( size > MAX_FILE_SIZE ){
		size = MAX_FILE_SIZE;
	}
	//! t@C̓ǂݍݗpobt@cĂꍇ́AU.
	if( m_FileBuff != NULL ){
		delete [] m_FileBuff;
		m_FileBuff = NULL;
	}
	try {
		//! t@CTCỸt@C̓ǂݍݗpobt@mۂ.
		m_FileBuff = new BYTE[size];

		//! t@Cǂݍݗpobt@1œǂݍ.
		DWORD readsize = file.Read( m_FileBuff, size );
		if( size != readsize ){
			size  = readsize;
		}
		//! t@CN[Y.
		file.Close();

		m_FileSize = size;
		return TRUE;

	}catch( ... ){
		TRACE0( "t@C̓ǂݍ݂Ɏs܂B\n" );

		//! t@C̓ǂݍ݂sꍇt@CN[Y.
		file.Close();
		return FALSE;
	}
}

/****************************************************************************/
/*!
 *	@brief	t@C̓e\.
 *
 *	@param	[in]	filename	ǂݍރt@C̐΃pX.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
BOOL	CMFCApp001Doc::ShowFile( CString& filename )
{
	//! t@Cǂݍ.
	if( !LoadFile( filename ) ){
		return FALSE;
	}
	//! t@Ce\EChEĕ`悷.
	CFileDataView* view = GetFileDataView();
	if( view != NULL ){
		view->Clear();
		view->InvalidateRect( NULL, FALSE );
	}
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	l؂肵ɕϊ.
 *
 *	@param	[in]	val		ϊ鐔l.
 *
 *	@retval	؂肵l̕.
 */
CString CMFCApp001Doc::DigitSeparator( LONGLONG val )
{
	/*
	 * 2^63 = 9,223,372,036,854,775,808 Ȃ̂ŕƏI[𑫂
	 * 25 + 1 + 1 = 27ƂȂ.
	 * (܂AL̂悢l32oCg̗̈m)
	 */
	char	str[32];
	int		i;
	int		comma = 0;
	BOOL	neg   = (val < 0) ? TRUE : FALSE;

	//! 1̈ʂ當ɕϊ.
	str[31] = '\0';
	for( i = 30; i > 0; i-- ){
		//! 10Ŋ]𕶎ɕϊĊi[.
		str[i] = '0' + (char)(val % 10);

		/*!
		 * l"0"ɂȂϊI.
		 * (breakꍇ́Ai͕̐擪wĂ)
		 */
		val = val / 10;
		if( val == 0 ){
			break;
		}
		/*!
		 * 3Ƃ','}.
		 * (̐擪J}ɂȂȂ悤ɏǏɃJ}})
		 */
		comma++;
		if( comma >= 3 ){
			i--;
			str[i] = ',';
			comma = 0;
		}
	}
	/*
	 * I[o[t[̏ꍇi̐擪1OɂȂĂ̂ŕ␳.
	 * (ɗ]T̂ŃI[o[t[͂Ȃ̂ŖĂǂ)
	 */
	if( i == 0 ){
		i--;
	}
	//! ̏ꍇ͕t.
	if( neg ){
		i--;
		str[i] = '-';
	}
	return CString( &(str[i]) );
}

/****************************************************************************/
/*!
 *	@brief	t@C\ptH[}bgɕϊ.
 *
 *	@param	[in]	fileTime	t@C.
 *
 *	@retval	"YYYY/MM/DD hh:mm"̌`ɕϊ.
 */
CString CMFCApp001Doc::ConvertFileDate( FILETIME& fileTime )
{
	//! t@C[Jɕϊ.
	FILETIME localTime;
	FileTimeToLocalFileTime( &fileTime, &localTime );

	//! [JVXeɕϊ.
	SYSTEMTIME sysTime;
	FileTimeToSystemTime( &localTime, &sysTime );

	//! "YYYY/MM/DD hh:mm"̌`ŕɂ.
	CString str;
	str.Format( _T("%4d/%02d/%02d %02d:%02d"), sysTime.wYear, sysTime.wMonth, sysTime.wDay, sysTime.wHour, sysTime.wMinute );

	return str;
}

#ifdef SHARED_HANDLERS
/****************************************************************************/
/*!
 *	@brief	kł̃T|[g
 *
 *	@param	[in]	dc			foCXReLXg.
 *	@param	[in]	lprcBounds	
 *
 *	@retval	Ȃ.
 */
void CMFCApp001Doc::OnDrawThumbnail( CDC& dc, LPRECT lprcBounds )
{
	// ̃R[hύXăhLg̃f[^`悵܂
	dc.FillSolidRect(lprcBounds, RGB(255, 255, 255));

	CString strText = _T("TODO: implement thumbnail drawing here");
	LOGFONT lf;

	CFont* pDefaultGUIFont = CFont::FromHandle((HFONT) GetStockObject(DEFAULT_GUI_FONT));
	pDefaultGUIFont->GetLogFont(&lf);
	lf.lfHeight = 36;

	CFont fontDraw;
	fontDraw.CreateFontIndirect(&lf);

	CFont* pOldFont = dc.SelectObject(&fontDraw);
	dc.DrawText(strText, lprcBounds, DT_CENTER | DT_WORDBREAK);
	dc.SelectObject(pOldFont);
}

/****************************************************************************/
/*!
 *	@brief	nh[̃T|[g.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void CMFCApp001Doc::InitializeSearchContent()
{
	CString strSearchContent;
	// hLg̃f[^猟Recݒ肵܂B
	// Rec̊e ";" ŋ؂Kv܂

	// :      strSearchContent = _T("point;rectangle;circle;ole object;");
	SetSearchContent(strSearchContent);
}

/****************************************************************************/
/*!
 *	@brief	
 *
 *	@param	[in]	value
 *
 *	@retval	Ȃ.
 */
void CMFCApp001Doc::SetSearchContent( const CString& value )
{
	if( value.IsEmpty() ){
		RemoveChunk( PKEY_Search_Contents.fmtid, PKEY_Search_Contents.pid );
	}else{
		CMFCFilterChunkValueImpl *pChunk = NULL;
		ATLTRY(pChunk = new CMFCFilterChunkValueImpl);
		if( pChunk != NULL ){
			pChunk->SetTextValue( PKEY_Search_Contents, value, CHUNK_TEXT );
			SetChunkValue(pChunk);
		}
	}
}
#endif // SHARED_HANDLERS

/****************************************************************************/
// CMFCApp001Doc ff
#ifdef _DEBUG
void CMFCApp001Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMFCApp001Doc::Dump( CDumpContext& dc ) const
{
	CDocument::Dump( dc );
}
#endif //_DEBUG

/* End of file */
