/****************************************************************************
 *	Copylight(C) 2018 Kanazawa-soft-design,LLC.
 ****************************************************************************/
/*!
 *	@file	MainFrm.cpp
 *
 *	@brief	AvP[ṼCEChE.
 *
 *	@author	V 閾
 */
#include "stdafx.h"
#include "MFCApp001.h"
#include "MainFrm.h"
#include "FileTreeView.h"
#include "FileListView.h"
#include "FileDataView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^[
//	ID_INDICATOR_CAPS,
//	ID_INDICATOR_NUM,
//	ID_INDICATOR_SCRL,
};

/****************************************************************************/
/*!
 *	@brief	RXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CMainFrame::CMainFrame()
{
}

/****************************************************************************/
/*!
 *	@brief	fXgN^.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
CMainFrame::~CMainFrame()
{
}

/****************************************************************************/
/*!
 *	@brief	EChEƂ̏ (WM_CREATE).
 *
 *	@param	[in]	lpCreateStruct	EChE̐\̂̃|C^.
 *
 *	@retval	0 = OK. / -1 = NG.
 */
int CMainFrame::OnCreate( LPCREATESTRUCT lpCreateStruct )
{
	//! ŏɊ{NX̃\bhĂяo.
	if( CFrameWnd::OnCreate( lpCreateStruct ) == -1 ){
		return -1;
	}
	//! Xe[^Xo[𐶐.
	if( !m_wndStatusBar.Create( this ) ){
		TRACE0( "Xe[^X o[̍쐬Ɏs܂B\n" );
		return -1;      // 쐬łȂꍇ
	}
	m_wndStatusBar.SetIndicators( indicators, sizeof(indicators) / sizeof(UINT) );

	return 0;
}

/****************************************************************************/
/*!
 *	@brief	OnCreate̎sɌĂ΂鏈.
 *
 *	@param	[in]	lpcs		EChE̐\̂̃|C^.
 *	@param	[in]	pContext	EChẼReLXg.
 *
 *	@retval	0 = OK. / -1 = NG.
 */
BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT lpcs, CCreateContext* pContext )
{
	//! E̕EChE쐬
	m_SplitWndMain.CreateStatic( this, 1, 2 );

	//! ẼEChE㉺ɕ.
	m_SplitWndSub.CreateStatic( &m_SplitWndMain, 2, 1, WS_CHILD | WS_VISIBLE, m_SplitWndMain.IdFromRowCol( 0, 1 ) );

	//! eEChEɃr[t.
	m_SplitWndMain.CreateView( 0, 0, RUNTIME_CLASS( CFileTreeView ), CSize( 200,   0 ), pContext );
	m_SplitWndSub.CreateView(  0, 0, RUNTIME_CLASS( CFileListView ), CSize(   0, 200 ), pContext );
	m_SplitWndSub.CreateView(  1, 0, RUNTIME_CLASS( CFileDataView ), CSize(   0,   0 ), pContext );

	//! ŌɊ{NX̃\bhĂяo.
	return CFrameWnd::OnCreateClient( lpcs, pContext );
}

BOOL CMainFrame::PreCreateWindow( CREATESTRUCT& cs )
{
	//! ŏɊ{NX̃\bhĂяo.
	if( !CFrameWnd::PreCreateWindow( cs ) ){
		return FALSE;
	}
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	Xe[^Xo[ɃbZ[W\.
 *
 *	@param	[in]	msg		\郁bZ[W.
 *
 *	@retval	Ȃ.
 */
void	CMainFrame::StatusMessage( CString& msg )
{
	m_wndStatusBar.SetPaneText( 0, msg );
}

/****************************************************************************/
// CMainFrame ff
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump( CDumpContext& dc ) const
{
	CFrameWnd::Dump( dc );
}
#endif //_DEBUG

/* End of file */
