/****************************************************************************
 *	Copylight(C) 2018 Kanazawa-soft-design,LLC.
 ****************************************************************************/
/*!
 *	@file	WrapScrollBar.h
 *
 *	@brief	XN[o[ (MFCp).
 *
 *	@author	V 閾
 */
#pragma once

class m_CWnd;

/****************************************************************************
 *
 * NX`.
 *
 ****************************************************************************/
/*!
 *
 *	@brief	XN[o[NX.
 *
 */
class CWrapScrollBar
{
public:
			 CWrapScrollBar();
	virtual ~CWrapScrollBar();

public:
	void	Bind( CWnd* wnd, int type );
	void	SetScrollBar( int maximum, int page, int pos, int scale );
	BOOL	SetScrollPos( int pos );
	BOOL	Action( UINT action );

	int		GetPos( void ) { return m_Pos; };

private:
	void	InternalInit( void );

private:
	CWnd*	m_CWnd;				//!< XN[o[\EChE.
	int		m_Type;				//!< SB_VERT=XN[o[ / SB_HORZ=XN[o[.
	int		m_Max;				//!< ő\.
	int		m_Pos;				//!< XN[o[̂܂݈ʒu.
	int		m_Page;				//!< 1ʂ̕.
	int		m_Scale;			//!< XN[ݕ.
};

/* End of file */
